#ifndef PATROL_SEQUENCE_H_
#define PATROL_SEQUENCE_H_

#include "run_ctrl.h"

#define MOVE_F STRAIGHT,45
#define MOVE_B STRAIGHT,-45
#define TURN_L ROTATE,-90
#define TURN_R ROTATE,90

struct patrol_data{
        int style;
        int value ; // distance[cm] or angle[deg]
} ;

//本番用

struct patrol_data pt_data[100] = {
        {TURN_R},
        {MOVE_B},
        {TURN_L},	// 3 宝確認	正体補正
        {TURN_R},	// 3 宝確認	正体補正
        {MOVE_F},
        {TURN_L-3},
        {MOVE_F},
        {TURN_R-2},
        {MOVE_F+3},	// 8 宝確認	正体補正
        {MOVE_F-5},
        {TURN_R-4},
//10
        {MOVE_F*2+3},	//11 宝確認
        {TURN_R},
        {MOVE_F*2+3},
        {TURN_L-3},
        {MOVE_F*2+3},
        {TURN_R},	//16 		正体補正
        {TURN_L+4},
        {MOVE_F*3+7},	//18 宝確認
        {TURN_R},
        {MOVE_F},	//20 宝確認	正体補正
//20
        {MOVE_F},
        {TURN_R},
        {MOVE_F},	//23		正体補正
        {TURN_L},
        {MOVE_F+2},
        {TURN_L-2},
        {MOVE_F},	//27 宝確認	正体補正
        {MOVE_B},
        {TURN_R},
        {MOVE_F*3+5},
//30
        {TURN_L},
        {MOVE_F},	//32 宝確認	正体補正
        {MOVE_B},
        {TURN_L},
        {MOVE_F*2},
        {TURN_L},
        {MOVE_F*2+3},	//37		正体補正
        {TURN_L},
        {MOVE_F*2+3},	//39 宝確認
        {MOVE_B},
//40
        {TURN_R},
        {MOVE_F*3+5},
        {TURN_L},
        {MOVE_F},	//44 		正体補正
        {MOVE_F},
        {TURN_R},
        {MOVE_F},	//47 宝確認	正体補正
        {MOVE_B},
        {TURN_R},
        {MOVE_F},	//50		正体補正
//50
        {MOVE_F},
        {TURN_L},
        {MOVE_F},
        {TURN_R},
        {MOVE_F},
        {TURN_R},
        {MOVE_F},	//55 宝確認	正体補正
        {MOVE_B},
        {TURN_L},
        {MOVE_F*2+3},
//60
        {TURN_R}
};

#endif
