#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "extern.h"
#include "define.h"

static int dir_num=2;
static int numbers[2];
//static int number_l=-1, number_r=-1;

/*
void number_get(int *num_l, int *num_r){
	*num_l = number_l;
	*num_r = number_r;

}
*/

//void number_get(int *num[2]){
void number_get(int num[2]){

	int i;
	for(i=0;i<dir_num;i++){
		num[i] = numbers[i];
	}

}

void number_set_nums(int nums){

	dir_num = nums;

}

//int number_detect(void){
int number_detect(int dist){
//*****変数定義*****
	int caperr = 0;
	//int i;
	//int xy1[4], xy2[4];
	IplImage *input = 0;
	IplImage *binr = 0;
	IplImage *trim = 0;
	IplImage *binr_t = 0;
	CvRect rect;
	CvSize cvsize;

	int count = 0;
	int num_1=-1,  num_2=-1;
	int x0_1=0, x0_2=0;
	int number = - 1;

//*****画像取得*****
	caperr = get_img("./img/input.jpg", IMG_X, IMG_Y);
	if(caperr != 0){	 //キャプチャが失敗したときの例外処理
		return -1;
	}
	input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);

//	cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input", input);
//	cvWaitKey(0);

//*****二値化*****
	binr = cvCreateImage(cvGetSize(input), IPL_DEPTH_8U,1);
	binarization(input, binr,1);
	cvSaveImage("./img/binr.jpg", binr, NULL);

//	cvNamedWindow("binr", CV_WINDOW_AUTOSIZE);	//コアダンプが起きるので消せない
//	cvShowImage("binr", binr);	//コアダンプが起きるので消せない
//	cvWaitKey(0);

//*****ラベリング*****

	int nums;
	int xy[10][4];
	
	//nums=labelling(binr, xy);
	nums=labelling(binr, xy, dist);

	printf("トリミングエリアとして抽出されたエリアの数 = %d\n",nums);

//条件にあったラベリング領域について、２個の数字が認識されるまで、トリミング、二値化、
//数字認識処理を行う

	int k;
	for(k=0;k<nums;k++){

		printf("triming number = %d\n",k);

	//*****トリミング*****
		rect = cvRect(xy[k][0], xy[k][1], xy[k][2] - xy[k][0], xy[k][3] - xy[k][1]);
		cvsize = cvSize(xy[k][2] - xy[k][0] + 2, xy[k][3] - xy[k][1] + 2);


		triming(input, rect);

		//printf("triming end \n");

		trim = cvLoadImage("./img/trim.jpg", CV_LOAD_IMAGE_COLOR);


	//*****トリミング画像の二値化*****

		binr_t = cvCreateImage(cvGetSize(trim), IPL_DEPTH_8U,1);
		//printf("binarization start\n");
		binarization(trim, binr_t, 0);


	//*****数字認識*****
		//printf("number_search start\n");
		number_search(binr_t, &number);

		//8と認識された数字に対して、縦横比が 0.3 より小さい場合は 1 とする。
		if( number == 8 && ( (float)cvsize.width / (float)cvsize.height < 0.3) ){
			printf("ROI捜査では8と認識されましたが、縦横比が %5.2f であるため 1 と判定します。\n",  (float)cvsize.width / (float)cvsize.height );
			number=1;
		}

		//printf("cvsize.width = %d\n",cvsize.width);
		//printf("cvsize.height = %d\n",cvsize.height);

		printf("number=%d\n", number);

		if(number >= 0 && number < 10){
			if(count==0){
				x0_1=xy[k][0];
				num_1=number;
				count++;
				if(count==dir_num) break; //1個数字認識のとき break する。
			}else{
				x0_2=xy[k][0];
				num_2=number;
				count++;
				break; // ２個数字が認識されたら break する
			}
		}

		usleep(100*1000); // 100ms間隔を置く

	}
	//--------------------------------------------------------

	//１個の数字認識の場合
	if(dir_num==1){
		numbers[0] = num_1;
		printf("left=%d\n", numbers[0]);
	}
	// ２個の数字が認識された場合のみ、左右の数字を入れる
	if(dir_num==2){
		if(count == 2){
			if(x0_1 < x0_2){
				numbers[0] = num_1;
				numbers[1] = num_2;
			}else{
				numbers[0] = num_2;
				numbers[1] = num_1;
			}
		}
		printf("left=%d,\t right=%d\n", numbers[0], numbers[1]);
	}


	cvReleaseImage(&input);
	cvReleaseImage(&binr);
	cvReleaseImage(&trim);
	cvReleaseImage(&binr_t);

	return 0;
}

