/*
PWM値を与えてモータ動作を確認するプログラム
created 2014/7/10
*/

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"

void test_pwm(){

	int pwm_duty_r, pwm_duty_l;
	unsigned char m_data[2];
	int fd_motor;
	int s_val;

	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);

	if(pwm_duty_l < 0) pwm_duty_l = 128 - pwm_duty_l;
	if(pwm_duty_r < 0) pwm_duty_r = 128 - pwm_duty_r;

	FILE *fp;
	int counter=0;
	int ret_val;

	fp=fopen("test.data","w");
	fd_motor=device_motor_get();

	while(1){
		counter++;

		//if(counter > 200) break;

		m_data[0]=pwm_duty_l;
		m_data[1]=pwm_duty_r;
		printf("%5d left_duty=%5d  right_duty=%5d\n",counter,m_data[0],m_data[1]);

		ret_val=write(fd_motor,m_data,2);

		usleep((T_TEST-1)*1000);
		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価

	}

	m_data[0]=0;
	m_data[1]=0;
	ret_val=write(fd_motor,m_data,2);

	fclose(fp);

	return ;

}



